@use 'theme';

$cv-blue-gray-600: theme.$color-basic-600;
$cv-gray-300: theme.$color-basic-300;
$cv-white: theme.$background-basic-color-1;
$cv-gray-100: theme.$color-basic-100;
$cv-gray-500: theme.$color-basic-500;
$cv-blue-500: theme.$color-primary-500;
$cv-gray-50: theme.$color-basic-100;
$cv-blue-600: theme.$color-primary-600;
$cv-blue-gray-400: theme.$color-primary-disabled;
$cv-gray-200: theme.$color-basic-200;
$cv-gray-400: theme.$color-basic-400;

@mixin overflow-tab($max) {
  @include theme.cv-truncate-line;

  display: block;
  max-width: $max;
}

:host {
  @include theme.width-height(100%, 100%);
  @include theme.flex-column;
  @include theme.min-width-min-height(0, 0);

  .tab-content {
    flex: 1;
    min-height: 0;
    min-width: 0;
  }

  .nav-wrapper {
    @include theme.box-shadow(0 1px 6px 1px rgba($cv-blue-gray-600, 0.15));

    overflow: hidden;
  }

  &.tabset-block > .nav-wrapper > .cv-nav-tabs {
    border-bottom: 1px solid $cv-gray-300;

    .nav-item {
      margin-bottom: -1px;
    }
  }

  .cv-nav-tabs {
    position: relative;
    z-index: 1;
    display: flex;
    background-color: $cv-gray-100;
    border-bottom: 1px solid $cv-gray-300;
  }

  > .nav-wrapper ::ng-deep .nav-item {
    padding: 0 16px;
    margin-bottom: -1px;
    border-style: solid;
    border-width: 3px 0 1px;
    border-color: transparent transparent $cv-gray-300;
    border-radius: 4px 4px 0 0;

    &:not(:first-child)::before {
      content: '';
      position: absolute;
      top: 25%;
      left: -1px;
      width: 1px;
      height: 50%;
      background-color: $cv-gray-300;
    }

    > .item__border {
      display: none;
      position: absolute;
      top: 0;
      width: 10px;
      height: 100%;
      background-color: $cv-white;

      &::before {
        content: '';
        display: block;
        position: absolute;
        top: 0;
        width: 50%;
        height: 100%;
        background-color: $cv-gray-100;
        border-bottom: 1px solid $cv-gray-300;
      }

      &--left {
        left: -4px;

        &::before {
          left: 0;
          border-radius: 0 0 4px;
          border-right: 1px solid $cv-gray-300;
        }
      }

      &--right {
        right: -4px;

        &::before {
          right: 0;
          border-radius: 0 0 0 4px;
          border-left: 1px solid $cv-gray-300;
        }
      }
    }

    &.disabled {
      pointer-events: none;
      color: $cv-gray-500;
    }

    &.active {
      @include theme.background-text-color($cv-white, $cv-blue-600);

      border-width: 3px 0 0;
      border-color: $cv-blue-500 $cv-gray-300;
      cursor: default;

      &::before {
        display: none;
      }

      > .item__border {
        z-index: 1;
        display: block;
      }

      .tab-icons {
        background-color: $cv-gray-50;
      }

      &:first-child {
        > .item__border--left {
          display: none;
        }
        border-color: $cv-blue-500 $cv-gray-300 transparent transparent;
      }
    }

    &:not(.active):hover {
      color: $cv-blue-600;
      cursor: pointer;

      .tab-icons {
        background-color: $cv-gray-100;
      }
    }

    .tab-title {
      @include overflow-tab(300px);
    }
  }

  &.white-mode .nav-wrapper .nav-item {
    @include theme.background-text-color($cv-white, $cv-blue-500);

    border: 0;
    border-bottom: 1px solid $cv-gray-400;
    padding: 1px 9px 0;

    &:not(.active):hover {
      background-color: $cv-gray-200;
    }

    &.active {
      border: 1px solid $cv-gray-400;
      border-bottom: 0;
      padding: 0 8px;
    }
  }

  &.blue-mode > .nav-wrapper {
    background-color: $cv-white;
    padding-left: 6px;
    padding-top: 8px;

    .nav-item {
      @include theme.background-text-color($cv-gray-100, $cv-blue-500);

      font-weight: bold;
      border: 0;
      border-top: 4px solid transparent;
      border-bottom: 4px solid $cv-gray-400;
      padding: 0 32px;
      line-height: 24px;

      &.active,
      &.active:focus,
      &.active:hover {
        @include theme.background-text-color($cv-blue-500, $cv-white);

        border-bottom-color: $cv-blue-500;
        font-weight: normal;
      }

      &.disabled {
        color: $cv-gray-500;
      }

      &:hover {
        background-color: $cv-gray-100;
        border-bottom-color: $cv-blue-500;
      }

      @media screen and (max-width: 1129px) {
        padding: 0 16px;
      }
    }
  }

  &.top-line-mode {
    .nav-wrapper {
      background-color: $cv-gray-100;
    }

    .nav-item {
      font-weight: bold;
      border: 0;
      border-top: 4px solid transparent;
      padding: 0 32px;
      line-height: 26px;
      height: 32px;

      &:first-child {
        border-left: 0;
      }

      &.active {
        background-color: $cv-gray-100;
        border-top-color: $cv-blue-500;
      }

      &:not(.active):hover {
        background-color: transparent;
      }
    }
  }

  &.primary-line-mode {
    .nav-wrapper {
      background-color: $cv-white;
      border-bottom: 1px solid $cv-gray-400;
    }

    .nav-item {
      @include theme.user-select(none);

      height: 30px;
      padding: 0 32px;
      background-color: $cv-white;
      border: 0;
      border-top: 4px solid transparent;
      border-bottom: 4px solid transparent;
      font-weight: normal;
      line-height: 24px;

      &:first-child {
        border-left: 0;
      }

      &.active,
      &.active:focus,
      &.active:hover {
        border-top-color: $cv-blue-500;
        color: $cv-blue-500;
      }

      &.disabled {
        border-top-color: transparent;
        color: $cv-gray-500;
        pointer-events: none;
      }

      &:hover {
        color: $cv-blue-500;
      }
    }
  }
}

::ng-deep .nav-item {
  @include theme.font(16px, 28px, null, $cv-blue-gray-400);
  @include theme.user-select(none);

  position: relative;
  height: 32px;
  white-space: nowrap;

  &:hover .tab-icons {
    display: block;
  }

  .tab-icons {
    @include theme.position-absolute(8px, 0);

    display: none;
    padding: 0 4px;
    height: 16px;
    line-height: 16px;
  }
}
